#!/bin/sh

for n in "$@"; do case ${n%%=*} in
  data) _DATA="${n#data=}";;
  exec) _exec="${n#exec=}";;
  noerr) exec 2>&-;;
esac; done

[ -z "${_EXEC%/}" ] && _EXEC="$(realpath "${0%/*}")" || _EXEC="${_EXEC%/}"
[ -z "${_DATA%/}" ] && _DATA=. || _DATA="${_DATA%/}"

file_pattern='^.*\.(mov|ts|mpg|mpeg|mp4|m4v|avi|mkv|flv|sfv|wmv|ogm|ogv|webm|iso|rmvb)$'

. "$_EXEC/cgilite/cgilite.sh"

FILTER="$(GET f)"
SEARCH="$(GET s)"
ORDER="$(GET o |grep -m1 -axE 'Date|Name|Length|Group' || printf Name)"
LISTSIZE="$(COOKIE pagesize |grep -m1 -axE '[1-9][0-9]*' || printf 50)"
ITEM="${PATH_INFO%/}"
ACTION="$(GET a)"

case $ACTION in
  setprefs)
    SET_COOKIE +$((86400 * 90))  pagesize="$(POST pagesize |grep -m1 -axE '[1-9][0-9]*' || printf 50)"
    SET_COOKIE +$((86400 * 90))      mode="$(POST     mode |grep -m1 -axE 'browse|index' || printf browse)"
    SET_COOKIE +$((86400 * 90))   fakemp4="$(POST  fakemp4 |grep -m1 -axE 'yes' || printf no)"
    SET_COOKIE +$((86400 * 90)) downscale="$(POST  downscale |grep -m1 -axE 'yes' || printf no)"
    [ "$(POST index)" = "update" ] && touch -cd @0 "${_DATA}/.index/meta.time"
    REDIRECT "$(POST ref)"
  ;;
  bookmark)
    bm="$_DATA/.index/bookmarks"
    . "$_EXEC/cgilite/storage.sh"

    s="$(POST search |STRING)"; f="$(POST filter |STRING)"
    if LOCK "$bm"; then
      grep -avF "	search=$s	filter=$f${CR}" "$bm" >"$bm.tmp"
      [ ! "$(POST delete)" ] \
      && printf '%s	search=%s	filter=%s\r\n' \
	        "$(POST name |STRING)" "$s" "$f" >>"$bm.tmp"
      mv "$bm.tmp" "$bm"
      RELEASE "$bm"
    fi
    REDIRECT "$(POST ref)"
  ;;
  multitag)
    . "$_EXEC/multitag.sh"
    REDIRECT "$(POST ref)"
  ;;
esac

if [ "$PATH_INFO" = "/style.css" ]; then
  . "$_EXEC/cgilite/file.sh"
  [ -r "$_DATA/$PATH_INFO" ] && FILE "$_DATA/$PATH_INFO" \
                        || FILE "$_EXEC/style.css"
elif [ "$PATH_INFO" = "/stereoview.js" ]; then
  . "$_EXEC/cgilite/file.sh"
  FILE "$_EXEC/stereoview.js"
elif [ -f "$_DATA/$PATH_INFO" ]; then
  case $ACTION in
    thumbnail)
      . "$_EXEC/cgilite/file.sh"
      . "$_EXEC/thumbnail.sh"
      index="$_DATA/${PATH_INFO%/*}/.index"
      thumb="$index/${PATH_INFO##*/}"; thumb="${thumb%.*}.jpg"
      [ -d "$index" -a ! -f "$thumb" ] \
      && { printf %s "$PATH_INFO" |grep -qE -e "${file_pattern}" ;} \
      && gen_thumb "$_DATA/$PATH_INFO" "$thumb"
      FILE "$thumb"
    ;;
    delete)
    ;;
    download)
      . "$_EXEC/cgilite/file.sh"
      fakemp4="$(COOKIE fakemp4)"
      downscale="$(COOKIE downscale)"
      downfile="$_DATA/${PATH_INFO%/*}/.transcode/${PATH_INFO%.*}.480p.webm"
      if [ "$downscale" = yes -a -f "$downfile" ]; then
        FILE "$downfile" "$([ "$fakemp4" = yes ] && printf 'video/mp4')"
      else
        FILE "$_DATA/$PATH_INFO" "$([ "$fakemp4" = yes ] && printf 'video/mp4')"
      fi
    ;;
    *) . "$_EXEC/view.sh"
  esac
elif [ -d "$_DATA/$PATH_INFO" ]; then
  case $ACTION in
    advsearch)
      . "$_EXEC/advsearch.sh"
    ;;
    spawnindex)
      if [ "$(POST recursive)" = yes ]; then
        find "$_DATA/$PATH_INFO" -depth -type d \! -name .index \
                            -exec mkdir -p '{}'/.index \;
      else
        mkdir -p "$_DATA/$PATH_INFO/.index"
      fi
      REDIRECT "$(POST ref)"
    ;;
    *) . "$_EXEC/list.sh"
    ;;
  esac
else
  printf 'Status: 404 Not Found\r\nContent-Length 0:\r\n\r\n'
fi
