#!/bin/sh

. "$_EXEC/cgilite/storage.sh"
. "$_EXEC/indexmeta.sh"

newtags=''
for tn in $(seq 1 $(POST_COUNT tag)); do
  newtags="$(POST tag $tn)${BR}${newtags}"
done
newtags="$(POST newtag |tr -d '\r' |tr , '\n')${BR}${newtags}"

while [ "${newtags#${BR}}" != "${newtags}" ]; do newtags="${newtags#${BR}}"; done
while [ "${newtags%${BR}}" != "${newtags}" ]; do newtags="${newtags%${BR}}"; done

[ "$(POST op)" = del ] && deltags="$newtags"

for select in $(seq 1 $(POST_COUNT select)); do
  file="$_DATA/$ITEM/$(POST select $select |PATH)"
  meta="${file%/*}/.index/meta"

  read -r length width height tags comment fn <<-EOF
	$(meta_info "$file")
	EOF
  tags="$(UNSTRING "${tags#tags=}" |tr , '\n')"

  if [ ! "$deltags" ]; then
    extags="$(printf '%s' "${newtags}" |grep -e "^-" |cut -d: -f1 )"
    [ "$extags" ] && tags="$(printf %s\\n "$tags" |grep -vwFe "$extags")"
    if printf %s "${newtags}" |grep -e "^-" |grep -qEe "^-[^:]+$"; then
      tags="$(printf %s\\n "$tags" |grep -vEe '^-[^:]+$')"
    fi
    tags="$(printf '%s\n' "${tags},${newtags}" \
            | tr , '\n' |sort -u |tr '\n' , \
            | STRING)"
  else
    detag="${deltags}${BR}"; while [ "$detag" ]; do
      tags="$(printf '%s\n' "$tags" |grep -vxFe "${detag%%${BR}*}")"
      detag="${detag#*${BR}}"
    done
    tags="$(printf '%s\n' "$tags" |sort -u |tr '\n' , |STRING)"
  fi
  tags="${tags#,}"; tags="${tags%,}"

  if LOCK "$meta"; then
    grep -avF "	$fn" "$meta" >"${meta}.tmp"

    printf '%i	%i	%i	tags=%s	comment=%s	%s\n' \
           "$length" "$width" "$height" "$tags" \
           "${comment#comment=}" "$fn" \
      >>"${meta}.tmp"
    mv "${meta}.tmp" "$meta"

    RELEASE "$meta"
  fi
done
